function Create(self)
	self.mapwrapx = SceneMan.SceneWrapsX;
	self.FireTimer = Timer();
	self.firecounter = 0;

	self.weaponname = "IBM"; -- PresetName of your gun
	self.mainparname = "Bullet IBM"; -- PresetName of main bullet particle
	self.tracerparname = "Tracer IBM"; -- PresetName of tracer bullet particle
	self.tracerprobability = 0.50; -- Probability of firing a tracer particle (0 for always main, 1.00 for always tracer)
	self.firespeed = 150; -- Speed of you particle
	self.firedelay = 55; -- delay between shots (miliseconds)
	self.parspread = 3; -- Spread of particles (degrees)
	self.parcount = 4; -- Number of particles per burst
	self.maxemitterframe = 5; -- Number of frames in emitter

	local curdist = 50;
   for i = 1,MovableMan:GetMOIDCount()-1 do
	gun = MovableMan:GetMOFromID(i);
    if gun.PresetName == self.weaponname and gun.ClassName == "HDFirearm" and (gun.Pos-self.Pos).Magnitude < curdist then
	actor = MovableMan:GetMOFromID(gun.RootID);
     if MovableMan:IsActor(actor) then
	self.parent = ToActor(actor);
	self.parentgun = ToHDFirearm(gun);
	local soundfx = CreateAEmitter("IBM Sound Fire"); -- Sound FX Emitter PresetName
	soundfx.Pos = self.parentgun.MuzzlePos;
	soundfx.Frame = math.random(0,self.maxemitterframe-1);
	soundfx.RotAngle = self.parent:GetAimAngle(true);
	MovableMan:AddParticle(soundfx);

	local randomnumber = math.random(1,100)/100;

      if randomnumber > self.tracerprobability then
	self.firepar = CreateMOPixel(self.mainparname);
      else
	self.firepar = CreateMOPixel(self.tracerparname);
      end

	self.firepar.Pos = self.parentgun.MuzzlePos;
	self.firepar.Vel = self.parent.Vel + (Vector(self.firespeed,0):RadRotate(self.parent:GetAimAngle(true))):DegRotate((math.random(-100,100)/100)*self.parspread);
	self.firepar:SetWhichMOToNotHit(self.parent,-1);
	MovableMan:AddParticle(self.firepar);

	self.firecounter = self.firecounter + 1;
	self.FireTimer:Reset();
     end
    end
   end

end

function Update(self)

   if MovableMan:IsActor(self.parent) and self.parentgun.RootID == self.parent.ID then
	self.ToDelete = false;
	self.ToSettle = false;
	self.PinStrength = 1000;
	self.Pos = self.parentgun.MuzzlePos;
    if self.FireTimer:IsPastSimMS(self.firedelay) and self.firecounter < self.parcount then
	self.FireTimer:Reset();
	self.firecounter = self.firecounter + 1;
	local soundfx = CreateAEmitter("IBM Sound Fire"); -- Sound FX Emitter PresetName
	soundfx.Pos = self.parentgun.MuzzlePos;
	soundfx.Frame = math.random(0,self.maxemitterframe-1);
	soundfx.RotAngle = self.parent:GetAimAngle(true);
	MovableMan:AddParticle(soundfx);

	local randomnumber = math.random(1,100)/100;

      if randomnumber > self.tracerprobability then
	self.firepar = CreateMOPixel(self.mainparname);
      else
	self.firepar = CreateMOPixel(self.tracerparname);
      end

	self.firepar.Pos = self.parentgun.MuzzlePos;
	self.firepar.Vel = self.parent.Vel + (Vector(self.firespeed,0):RadRotate(self.parent:GetAimAngle(true))):DegRotate((math.random(-100,100)/100)*self.parspread);
	self.firepar:SetWhichMOToNotHit(self.parent,-1);
	MovableMan:AddParticle(self.firepar);

    elseif self.firecounter >= self.parcount then
	self.ToDelete = true;
    end
   else
	self.ToDelete = true;
   end

end